/*
plucache.cpp 
Copyright (C) 2001  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#include <pthread.h>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cerrno>
#include <ctime>

#include "pos.h"
#include "sql.h"
#include "plucache.h"

pthread_mutex_t plu_busy=PTHREAD_MUTEX_INITIALIZER;

#ifdef _DEBUGGERY
extern int DebugLevel;
#endif


PluCacheItem::PluCacheItem()
{
   bEphemeral=false;
   strcpy(Plu, "");
	strcpy(displayText, "");
	strcpy(recuText, "");
   productID=0;
   nameID=0;
	promoID=0;
	tax=0.0;
	discount=0.0;
	deposittype=0;
	deposit=0.0;
	unitPrice=0.0;
	flags=0;
}

PluCacheItem::PluCacheItem(PluCacheItem const& p)
{
   bEphemeral=p.bEphemeral;
   strcpy(Plu, p.Plu);
	strcpy(displayText, p.displayText);
	strcpy(recuText, p.recuText);
   productID=p.productID;
   nameID=p.nameID;
	promoID=p.promoID;
	tax=p.tax;
	discount=p.discount;
	deposittype=p.deposittype;
	deposit=p.deposit;
	unitPrice=p.unitPrice;
	flags=p.flags;
}

PluCacheItem::~PluCacheItem()
{
}

PluCacheItem &PluCacheItem::operator=(const PluCacheItem& p)
{
   this->bEphemeral=p.bEphemeral;
   strcpy(this->Plu, p.Plu);
	strcpy(this->displayText, p.displayText);
	strcpy(this->recuText, p.recuText);
   this->productID=p.productID;
   this->nameID=p.nameID;
	this->promoID=p.promoID;
	this->tax=p.tax;
	this->discount=p.discount;
	this->deposittype=p.deposittype;
	this->deposit=p.deposit;
	this->unitPrice=p.unitPrice;
	this->flags=p.flags;
   
   return *this;
}

void PluCacheItem::Clear()
{
   bEphemeral=false;
   strcpy(Plu, "");
	strcpy(displayText, "");
	strcpy(recuText, "");
   productID=0;
   nameID=0;
	promoID=0;
	tax=0.0;
	discount=0.0;
	deposittype=0;
	deposit=0.0;
	unitPrice=0.0;
	flags=0;
}
void PluCacheItem::SetPLU(char *p)
{
	if(p) strcpy(Plu, p);
}
void PluCacheItem::SetProductID(int p)
{
	productID=p;
}
void PluCacheItem::SetNameID(int n)
{
	nameID=n;
}
void PluCacheItem::SetDispText(char *t)
{
	if(t) strcpy(displayText, t);
}
void PluCacheItem::SetRecText(char *t)
{
	if(t) strcpy(recuText, t);
}
void PluCacheItem::SetPromoID(int p)
{
	promoID=p;
}
void PluCacheItem::SetTax(double f)
{
	tax=f;
}
void PluCacheItem::SetDiscount(double f)
{
	discount=f;
}
void PluCacheItem::SetPrice(double f)
{
	unitPrice=f;
}
void PluCacheItem::SetEphemeral(bool b)
{
   bEphemeral=b;
}
void PluCacheItem::SetDepositType(int t)
{
   deposittype=t;
}
void PluCacheItem::SetDeposit(double d)
{
   deposit=d;
}
char *PluCacheItem::GetPlu()
{
	return Plu;
}
int PluCacheItem::GetProductID()
{
	return productID;
}
int PluCacheItem::GetNameID()
{
	return nameID;
}
void PluCacheItem::SetFlags(int f)
{
	flags=f;
}
char *PluCacheItem::GetDispText()
{
	return displayText;
}
char *PluCacheItem::GetRecuText()
{
	return recuText;
}
int PluCacheItem::GetPromoID()
{
	return promoID;
}
double PluCacheItem::GetTax()
{
	return tax;
}
double PluCacheItem::GetDiscount()
{
	return discount;
}
int PluCacheItem::GetDepositType()
{
	return deposittype;
}
double PluCacheItem::GetDeposit()
{
	return deposit;
}
double PluCacheItem::GetPrice()
{
	return unitPrice;
}
int PluCacheItem::GetFlags()
{
	return flags;
}
bool PluCacheItem::GetEphemeral()
{
   return bEphemeral;
}
/*
bool PluCacheItem::operator==(const char *p, const int n)
{
	if(strcmp(p, Plu)==0 && nameID=n) return true;
	return false;
}*/
bool PluCacheItem::operator==(const PluCacheItem& p)
{
	if((strcmp(Plu, p.Plu)==0) && nameID==p.nameID) return true;
	return false;
}
bool PluCacheItem::operator!=(const PluCacheItem& p)
{
	if((strcmp(Plu, p.Plu)!=0) && nameID!=p.nameID) return true;
	return false;
}
bool PluCacheItem::operator<(const PluCacheItem& p)
{
	if(strcmp(Plu, p.Plu) < 0) return true;
	return false;
}


/////////////////////////////////////////////////////////////
//
//
//
//
//
////////////////////////////////////////////////////////////

CPluCache::CPluCache()
{
}

CPluCache::~CPluCache()
{
	cache.clear();
	pthread_mutex_destroy(&plu_busy);
}

bool CPluCache::Add(PluCacheItem& p)
{
	// need a FindInsertPoint algorithm
	return false;
}

bool CPluCache::Remove(PluCacheItem& p)
{
	cache.remove(p);
	return false;
}

bool CPluCache::Reload(bhpos::BhSQL *db, int cache_limit, char *precache)
{
	bhpos::BhSQLResult  sql_result;
	char			        sql_query[256];
	bhpos::BhSQLRow	 *row;
	PluCacheItem	     item;
	
	pthread_mutex_lock(&plu_busy);

   if(!cache.empty()) cache.clear();

	if(precache){
		sprintf(sql_query, "SELECT * FROM %s LIMIT %d", precache, cache_limit);
	}
	else{
      sprintf(sql_query, "SELECT * FROM plu_cache LIMIT %d", cache_limit);
	}
	sql_result.init(db, sql_query, true);
#ifdef _DEBUGGERY		
	if(DebugLevel>1){
		printf("PLUServer: PLU Cache query returned: %d rows\n", sql_result.NumRows());
	}
#endif
		
	if(sql_result.NumRows() > 0){
		while((row=sql_result.GetRow())){
		   item.Clear();
         item.SetProductID(atoi(row->GetField(1)));
         item.SetNameID(atoi(row->GetField(2)));
			item.SetPLU(row->GetField(3));
			item.SetDispText(row->GetField(4));
			item.SetRecText(row->GetField(5));
         item.SetPrice(atof(row->GetField(6)));
			item.SetDiscount(atof(row->GetField(7)));
         item.SetDepositType(atoi(row->GetField(8)));
	      item.SetDeposit(atof(row->GetField(9)));
			item.SetTax(atof(row->GetField(10)));
			item.SetFlags(atoi(row->GetField(11)));
			cache.push_back(item);
		}
	}
#ifdef _DEBUGGERY		
	if(DebugLevel>1){
		printf("PLUServer: PLU Cache query returned: %d\n", cache.size());
	}
#endif
	pthread_mutex_unlock(&plu_busy);
	
#ifdef _DEBUGGERY		
	if(DebugLevel>2){
		printf("PLUServer: PLU mutex done\n");
	}
#endif	
	return false;
}

bool CPluCache::Replace(PluCacheItem& r)
{
	std::list<PluCacheItem>::iterator iter;
	
	pthread_mutex_lock(&plu_busy);
	iter=find(cache.begin(), cache.end(), r);
	if(iter==cache.end()){
		pthread_mutex_unlock(&plu_busy);
		return true;
	}
	*iter=r;
	
	pthread_mutex_unlock(&plu_busy);
	return false;
}

bool CPluCache::Find(PluCacheItem& r)
{
	std::list<PluCacheItem>::iterator iter;

#ifdef _DEBUGGERY		
	if(DebugLevel>1){
		printf("CPluCache::Find() for PLU: %s\n", r.GetPlu());
	}
#endif
	
	pthread_mutex_lock(&plu_busy);
	iter=find(cache.begin(), cache.end(), r);
	if(iter==cache.end()){
#ifdef _DEBUGGERY		
	   if(DebugLevel>1){
		   printf("CPluCache::Find() PLU not found in cache.\n");
	   }
#endif		
		pthread_mutex_unlock(&plu_busy);
		return false;
	}
	r=*iter;
	
	if(r.GetEphemeral()) cache.erase(iter);
	
	pthread_mutex_unlock(&plu_busy);
	return true;
}
